
// Layout is: "name", hexsize, crc, sha1

var PxInfo = new Array(
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, "")
);

var S1Info = new Array(0, 0, 0, "");

var CxInfo = new Array(
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, "")
);

var M1Info = new Array(0, 0, 0, "");
var M1dInfo = new Array(0, 0, 0, "");

var VxInfo = new Array(
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, ""),
	new Array(0, 0, 0, "")
);

// get offset lengths
function getlen(type, start, end, extra)
{
	var size = 0;
	for (var i = start; i < (end+1); i++)
	{
		if (document.gen["chxbx" + type + i].checked)
			size += eval(document.gen[type + i + "size"].value);
	}

	if (extra&1) size = toHex(size);
	if (extra&2) size = size.slice(0, size.length-1)+"1";

	return size;
}

// calc FBA hash
function fba_hash(input)
{
	if (input.length < 7) return 0;
	return "0x" + input;
}


// Do actual name generation
function do_name_gen(form, type, input)
{
	var d = "";
	if ((type.slice(0,1) == "c") && (form.addd.checked != "")) d = "d";

	if (((input == ("xxx-" + type + ".bin"))||(form.parsed.value == 1)) && (form.usegen.checked))
	{
		if ((type == "m1d")&&(form.chxbxm1.checked == false))
		{
			type = "m1";
		}

		rom_name = form.name.value + form.sepr.value + type + d + form.ext.value;
	} else
		rom_name = input;

	return rom_name;
}

// This is for adding 0 before small (less than 1mb) rom sizes in FBA and MAME.
function add_zero_sizes(form, input)
{
	var zero = "";
	if ((form.picker.value != "nebula") && (input <= eval(1048575))) zero = "0";

	return (zero + toHex(input));
}

// Check for incorrect Hash
function mame_crc(input, begin, end, l)
{
	var output = begin + input + end;
	if (output.length < (begin.length + end.length + l)) output = "NO_DUMP";

	return output;
}

// add 0's to the offset (cosmetic)
function mame_offset(tlen, ofst)
{
	var tmp = ofst;
	for (i = 0; i < (tlen.length-ofst.length); i++)
	{
		tmp = "0" + tmp;
	}
	return tmp;
}

// RomCenter generation (incomplete)
function rc_gen(form, begin, type, name, is_clone)
{
	var output = "";
	if (form["chxbx" + type].checked)
	{
		var crc = form[type + "crc"].value;
		if (crc.length < 7) crc = 0;
		output += begin + name + "" + crc + "" + form[type + "size"].value + "";
		if ((is_clone == 1)&&(form["merged" + type].value == 1))
		{
			output += form.parentname.value + "";
			output += form[type + "name"].value;
			return output + "\n";
		} else {

			return output + "neogeo\n";
		}
	}
	return "";
}

function store_info(form, Info, type, i)
{
	Info[0] = do_name_gen(form, type + i, form[type + i + "name"].value);
	Info[1] = add_zero_sizes(form, form[type + i + "size"].value);
	Info[2] = form[type + i + "crc"].value;
	if ((form[type+i+"sha1"].value) && (form.usesha.value == "1"))
		Info[3] = " SHA1(" + form[type+i+"sha1"].value + ")";
	else
		Info[3] = "";
}

function getRomInfo(form) // clear then get rom info
{
	for (i = 1; i < 4; i++)
		store_info(form, PxInfo[i-1], "p", i);

	for (i = 1; i < 9; i++)
		store_info(form, CxInfo[i-1], "c", i);

	for (i = 1; i < 6; i++)
		store_info(form, VxInfo[i-1], "v", i);

	store_info(form, S1Info,  "s",    1);
	store_info(form, M1Info,  "m",    1);
	store_info(form, M1dInfo, "m1d", "");

	// not exactly rom info, but needs to be gotten at some point
	if (form.cartidn.value == "") {
		var toslice = PxInfo[0][0];
		if (form.usegen.checked) toslice = form.name.value;
		toslice = toslice.slice(0,4).replace(/-/gi, "");
		toslice = toslice.replace(/_/gi, "");
		if (toslice == "xxx") toslice = "";
		form.cartidn.value = toslice;
	}
}


function do_opera_check()
{
	var brs = navigator.userAgent.toLowerCase();
	for (i = 0; i < brs.length; i++) {
		if (brs.slice(i, i+5) == "opera") {
			return 1;
		}
	}
	return 0;
}

  /*---------------------------------------------------------------------------------------------------*\
  |  I'm not sure who wrote this decimal to hex stuff, but here's the site where I found it:		|
  |  http://javascript.about.com/library/blh2d.htm							|
  |  Please note that I have made some modifications to the original code.     				|
  \*---------------------------------------------------------------------------------------------------*/

function toHex(d)
{
	var hD="0123456789ABCDEF";
	var h = hD.substr(d&15,1);
	while(d>15) {
		d>>=4;
		h=hD.substr(d&15,1)+h;
	}
	return h;
}

